#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define pll pair<ll, ll>
#define pdd pair<ld, ld>
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

const int kMaxN = 5005;

int n;
int sub[kMaxN];
vector<int> v[kMaxN];
int black[kMaxN][kMaxN];
int new_black[kMaxN];
int white[kMaxN];

void Reset() {
  for (int i = 1; i <= n; i++) {
    v[i].clear();
    sub[i] = 0;
  }

  memset(black, -1, sizeof(black));
  memset(white, -1, sizeof(white));
}

void Dfs(int x) {
  sub[x] = 1;
  white[x] = 0;
  black[x][0] = 0;

  for (int i = 0; i <= n; i++) {
    new_black[i] = -1;
  }

  for (auto y : v[x]) {
    if (!sub[y]) {
      Dfs(y);

      for (int i = 0; i < sub[x]; i++) {
        for (int j = 0; j < sub[y]; j++) {
          if (black[x][i] != -1 && black[y][j] != -1) {
            new_black[i + j] = max(new_black[i + j],
                                      black[x][i] + black[y][j] + j * i);
          }
        }
        if (black[x][i] != -1) {
          new_black[i + 1] = max(new_black[i + 1], black[x][i] + white[y] + i);
        }
      }

      int best_from_y = white[y] + 1;
      for (int i = 0; i <= sub[y]; i++) {
        if (black[y][i] != -1) {
          best_from_y = max(best_from_y, black[y][i] + i);
        }
      }

      white[x] += best_from_y;

      sub[x] += sub[y];
      for (int i = 0; i <= sub[x]; i++) {
        black[x][i] = new_black[i];
        new_black[i] = -1;
      }
    }
  }
}

int main() {
  cin.sync_with_stdio(false);

  ifstream cin("tricolor.in");
  ofstream cout("tricolor.out");

  int t;
  cin >> t;
  for (; t; t--) {
    cin >> n;
    Reset();

    for (int i = 1; i < n; i++) {
      int x, y;
      cin >> x >> y;
      v[x].pb(y);
      v[y].pb(x);
    }

    Dfs(1);

    int ans = white[1];
    for (int i = 0; i <= n; i++) {
      ans = max(ans, black[1][i]);
    }

    cout << ans << '\n';
  }

  return 0;
}
