#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

const int kMaxN = 500, kInf = (1 << 30);

int compress_size;
int dp[kMaxN][kMaxN][26];
int mn_length[kMaxN];

bool CanCompress(int li, int lf) {
    for (int i = 0; i < 26; ++i) {
        if (dp[li][lf][i] >= compress_size) {
            return true;
        }
    }    
    return false;
}

void UpdateMax(int& x, int y) {
    if (x < y) {
        x = y;
    }    
}

void ComputeTransitions(int li, int ki, int kf, int lf) {
    for (int ch = 0; ch < 26; ++ch) {
        if (dp[li][ki][ch] != -kInf and dp[kf][lf][ch] != -kInf) {
            UpdateMax(dp[li][lf][ch], 
                dp[li][ki][ch] + dp[kf][lf][ch]);
        }
    }
    
    if (CanCompress(li, ki)) {
        for (int ch = 0; ch < 26; ++ch) {
            UpdateMax(dp[li][lf][ch], dp[kf][lf][ch]);
        }
    }
    
    if (CanCompress(kf, lf)) {
        for (int ch = 0; ch < 26; ++ch) {
            UpdateMax(dp[li][lf][ch], dp[li][ki][ch]);
        }        
    }
}

int main() {
    ifstream cin("zuma.in");
    ofstream cout("zuma.out");
    int n; string s; cin >> n >> compress_size >> s;
    
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            for (int ch = 0; ch < 26; ++ch) {
                dp[i][j][ch] = -kInf;
            }
        }
    }
    for (int li = n - 1; li >= 0; --li) {
        dp[li][li][s[li] - 'A'] = 1;
        for (int lf = li + 1; lf < n; ++lf) {
            for (int k = li; k < lf; ++k) {
                ComputeTransitions(li, k, k + 1, lf);
            }
        }
    }
    
    for (int i = 0; i < n; ++i) {
        if (CanCompress(0, i)) {
            mn_length[i] = 0;
        } else {
            mn_length[i] = 1 + (i > 0 ? mn_length[i - 1] : 0);
            for (int j = i - 1; j >= 0; --j) {
                if (mn_length[j] < mn_length[i] and CanCompress(j + 1, i)) {
                    mn_length[i] = mn_length[j];
                }
            }
        }
    }
    cout << mn_length[n - 1] << endl;
}