// Andrei-Costin Constantinescu - Oxford University
// O(N^2)
#include <bits/stdc++.h>

using namespace std;

const int NMAX = 2000;
const int VALMAX = 1000000;

int N, K;
vector <int> v;
vector <vector <vector <int> > > dp;

inline void updVal(int &where, const int val) {
    if (where == -1 || val < where)
        where = val;
}

int main() {
    freopen("antivirus.in", "r", stdin);
    freopen("antivirus.out", "w", stdout);

    int T;
    cin >> T;

    for (; T; T--) {
      v.clear();
      dp.clear();

      cin >> N >> K;
      assert(1 <= N && N <= NMAX);

      // Read
      v.push_back(0);
      int zeroes = 0;
      for (int i = 1; i <= N; ++ i) {
          int val;
          cin >> val;
          zeroes += (val == 0);
          assert(0 <= val && val <= VALMAX);
          v.push_back(val);
      }
      assert(zeroes <= K && K <= N);

      dp.push_back(vector <vector <int> >(K + 1, vector <int>(3, -1)));
      dp[0][0][0] = 0;

      for (int i = 0; i < N; ++ i) {
          dp.push_back(vector <vector <int> >(K + 1, vector <int>(3, -1)));
          for (int j = 0; j <= K; ++ j) {
              if (v[i + 1] == 0) {
                  if (dp[i][j][0] != -1 && j + 1 <= K)
                      updVal(dp[i + 1][j + 1][2], dp[i][j][0]);
                  if (dp[i][j][1] != -1 && j + 1 <= K)
                      updVal(dp[i + 1][j + 1][2], dp[i][j][1]);
                  if (dp[i][j][2] != -1 && j + 1 <= K)
                      updVal(dp[i + 1][j + 1][2], dp[i][j][2]);
              }
              else {
                  if (dp[i][j][0] != -1) {
                      updVal(dp[i + 1][j][0], dp[i][j][0]);
                      if (j + 1 <= K)
                          updVal(dp[i + 1][j + 1][1], dp[i][j][0] + v[i + 1]);
                  }
                  if (dp[i][j][1] != -1 && j + 1 <= K)
                      updVal(dp[i + 1][j + 1][1], dp[i][j][1] + v[i + 1]);

                  if (dp[i][j][2] != -1) {
                      if (j + 1 <= K)
                          updVal(dp[i + 1][j + 1][2], dp[i][j][2] + v[i + 1]);
                      updVal(dp[i + 1][j][0], dp[i][j][2]);
                  }
              }
          }
      }

      int ans = -1;
      for (int i = 0; i < 3; ++ i)
          if (i != 1 && dp[N][K][i] != -1)
              updVal(ans, dp[N][K][i]);
      cout << ans << '\n';
    }

    return 0;
}
