// Andrei-Costin Constantinescu - Oxford University
// O(N^3)
#include <bits/stdc++.h>

using namespace std;

const int NMAX = 2000;
const int VALMAX = 1000000;

int N, K;
vector <int> v;
vector <int> sPart;

vector <vector <int> > dp;

inline int getSum(int l, int r) {
    assert(l > 0), assert(l <= r);
    assert(sPart[r] - sPart[l - 1] >= 0);
    return sPart[r] - sPart[l - 1];
}
inline void updVal(int &where, const int val) {
    if (where == -1 || val < where)
        where = val;
}

int main() {
    freopen("antivirus.in", "r", stdin);
    freopen("antivirus.out", "w", stdout);

    int T;
    cin >> T;

    for (; T; T--) {
      v.clear();
      sPart.clear();
      dp.clear();

      cin >> N >> K;
      assert(1 <= N && N <= NMAX);

      // Read
      v.push_back(0), sPart.push_back(0);
      int zeroes = 0;
      for (int i = 1; i <= N; ++ i) {
          int val;
          cin >> val;
          zeroes += (val == 0);
          assert(0 <= val && val <= VALMAX);
          v.push_back(val), sPart.push_back(sPart.back() + val);
      }

      assert(zeroes <= K && K <= N);

      // Add sentinel zero
      ++ N, ++ K;
      v.push_back(0);
      ++ zeroes;
      sPart.push_back(sPart.back());

      vector <int> zrs = {0};
      for (int i = 1; i <= N; ++ i)
          if (!v[i])
              zrs.push_back(i);

      dp.push_back(vector <int>(K + 1, -1)), dp.push_back(vector <int>(K + 1, -1));
      const int fstPs = zrs[1];

      for (int i = fstPs; i >= 1; -- i)
          if (fstPs - i + 1 <= K)
              dp[1][fstPs - i + 1] = getSum(i, fstPs);

      for (int i = 2; i < zrs.size(); ++ i) {
          dp.push_back(vector <int>(K + 1, -1));
          const int a = zrs[i - 1], b = zrs[i];
          for (int knap = 0; knap <= K; ++ knap) {
              for (int j = a; j <= b; ++ j)
                  for (int k = j + 1; k <= b; ++ k) {
                      if (i + 1 == zrs.size() && k < b)
                          continue;
                      if (knap - (b - k + 1 + j - a) >= 0 && dp[i - 1][knap - (b - k + 1 + j - a)] != -1)
                          updVal(dp[i][knap], dp[i - 1][knap - (b - k + 1 + j - a)] + getSum(a, j) + getSum(k, b));
                  }
          }
      }
      cout << dp.back()[K] << '\n';
    }
    return 0;
}
