#include <bits/stdc++.h>

using namespace std;

const int NITER = 1000;

using it_t = string::iterator;

int random_int(int low, int high)
{
    uniform_int_distribution<> d(low, high);
    static default_random_engine gen;
    return d(gen);
}

template<typename T>
T random_choice(const vector<T>& v)
{
    assert (!v.empty());

    return v[random_int(0, v.size() - 1)];
}

struct Solver {

    int n, k;

    Solver(int n, int k):
        n(n),
        k(k)
    { }

    vector<pair<it_t, it_t>> splits(string& s) const
    {
        vector<pair<it_t, it_t>> candids;

        for (auto i = s.begin(); i != s.end();) {
            auto j = i;
            j++;

            while (j != s.end() && *i == *j) {
                j++;
            }

            if (j - i >= k) {
                candids.push_back({i, j});
            }

            i = j;
        }
        return candids;
    }

    int back(string s) const
    {
        auto candids = splits(s);
        if (candids.empty()) {
            return s.size();
        }

        int best = s.size();
        for (auto c : candids) {
            string now = s;
            it_t i, j;
            tie(i, j) = c;

            now.erase(now.begin() + (i - s.begin()), now.begin() + (j - s.begin()));

            int posib = back(now);
            if (posib < best) {
                best = posib;
            }
        }
        return best;
    }

    int solve(string s)
    {
        return back(s);
    }
};

int main()
{
    ifstream fin("zuma.in");
    ofstream fout("zuma.out");
    int n, k;
    fin >> n >> k;
    string s;
    fin >> s;

    assert (s.length() == static_cast<size_t>(n));

    Solver solver(n, k);
    fout << solver.solve(s) << "\n";
    return 0;
}
