#include<stdio.h>
#include<string.h>
#include<vector>
using namespace std;

#define NMAX 200005

vector<int> solution, tree[NMAX];
int mark[NMAX], cuplajTree[NMAX], cuplaj[NMAX], t, n;
char viz[NMAX], ok = 0;

void clearAll() {
    memset(viz, 0, sizeof(viz));
    memset(mark, 0, sizeof(mark));
    memset(cuplaj, 0, sizeof(cuplaj));
    memset(cuplajTree, 0, sizeof(cuplajTree));
    for(int i = 1; i <= 2 * n; i++)
        tree[i].clear();
    solution.clear();
}

inline void dfs(int node) {
    viz[node] = 1;

    int lim = tree[node].size(), neigh;
    for(int i = 0; i < lim; i++ && !ok) {
        if(viz[neigh = tree[node][i]])
            continue;
        dfs(neigh);
        if(cuplajTree[neigh])
            continue;
        if(cuplajTree[node]) {
            ok = 1;
            return ;
        }
        cuplajTree[node] = neigh;
        cuplajTree[neigh] = node;
    }
}

inline void getSolution(int node) {
    for(int timp = 1 ; timp <= 2 * n + 1; timp++) {
        mark[node]++;
        if(mark[node] > 1)
            return ;
        solution.push_back(node);

        if(timp&1)
            node = cuplaj[node];
        else
            node = cuplajTree[node];
    }
}

int main () {
    int a, b;

    freopen("dungeon.in","r",stdin);
    freopen("dungeon.out","w",stdout);

    scanf("%d", &t);
    for( ; t; t--) {
        scanf("%d",&n);
        for(int i = 1; i < n; i++) {
            scanf("%d%d",&a,&b);
            tree[a].push_back(b);
            tree[b].push_back(a);
        }
        for(int i = 1; i < n; i++) {
            scanf("%d%d",&a,&b);
            tree[a].push_back(b);
            tree[b].push_back(a);
        }
        for(int i = 1; i <= n; i++) {
            scanf("%d%d",&a,&b);
            cuplaj[a] = b;
            cuplaj[b] = a;
        }
        if(n&1) {
            printf("-1\n");
            clearAll();
            continue;
        }
        ok = 0;
        dfs(1);
        dfs(n + 1);

        if(!ok)
            getSolution(1);
        int nr = solution.size();
        if(ok || nr != 2 * n || mark[1] != 2)
            printf("-1\n");
        else {
            for(int i = 0; i < 2 * n; i++)
                printf("%d ", solution[i]);
            printf("\n");
        }
        clearAll();
    }

    return 0;
}


