// O(2^n * n)

#include <fstream>
#include <iostream>
#include <vector>

using namespace std;
using Matrix = vector<vector<int>>;

int sol, current_config; 

void dfs(int node, Matrix& graph, vector<int>& dp, vector<bool>& used) {
  int sum = 0;
  bool color;
  if (current_config&(1 << node))
      color = true;
  else color = false;

  used[node] = true;
  if (color == false) // white 
    dp[node] = 0;
  else
    dp[node] = 1; // black

  for (auto other : graph[node]) {
    if (!used[other]) {
      dfs(other, graph, dp, used);
      if (color == false) {
        sum += dp[other];
        sol -= dp[other] * dp[other];
        dp[node] += dp[other];
      }
      else {
        sol += 2 * dp[other];
      }
    }
  }
  if (color == false) {
    sum = sum * sum;
    sol += sum;
  }
 // cerr << node + 1 << " " << dp[node] << "\n";
}

int solve(int config, int n, Matrix& graph) {
  sol = 0;
  vector<int> dp(n);
  vector<bool> used(n);

  current_config = config;
  dfs(0, graph, dp, used);
  return sol;
}

int main() {
  int t, n, a, b;
  ifstream cin("tricolor.in");
  ofstream cout("tricolor.out");
  cin >> t;
  while(t--) {
    cin >> n;
    Matrix graph(n, vector<int>());
    for (int i = 0; i < n - 1; ++i) {
      cin >> a >> b;
      --a;
      --b;
      graph[a].push_back(b);
      graph[b].push_back(a);
    }
    int solutions = (1 << n), ans = 0, cnt = 0;
    for (int config = 0; config < solutions; ++config) {
      a = solve(config, n, graph);
      if (a > ans) {
        ans = a;
      }
    }
    cout << ans / 2<< "\n";
  }
  return 0;
}
