#include <iostream>
#include <cassert>
#include <vector>

using namespace std;
using Matrix = vector<vector<int>>;

const int NMAX = 5e5;

int main() {
  int n;
  cin >> n;
  assert(n <= NMAX);

  Matrix st(3, vector<int>(n));
  vector<int> top(3, -1);
  vector<bool> f(n + 1);
  for (int i = 0; i < n; ++i) {
    cin >> st[0][i];
    assert(1 <= st[0][i] && st[0][i] <= n);
    assert(f[st[0][i]] == false);
    f[st[0][i]] = true;
  }

  int maxBit;
  for (maxBit = 1; (1 << maxBit) < n; ++maxBit);

  vector<pair<int, int>> ans;
//  cerr << "MAXBIT = " << maxBit << "\n";
  for (int b = 0; b <= maxBit; ++b) {
    for (int i = n - 1; i >= 0; --i) {
      if (st[0][i] & (1 << b)) {
        ans.emplace_back(0, 1);
        st[1][++top[1]] = st[0][i];
      }
      else {
        ans.emplace_back(0, 2);
        st[2][++top[2]] = st[0][i];
      }
    }
    top[0] = -1;
    for (int j = 2; j >= 1; --j) {
      for (int i = top[j]; i >= 0; --i) {
        ans.emplace_back(j, 0);
        --top[j];
        st[0][++top[0]] = st[j][i];
      }
    }
  }

/*  cerr << "START\n";
  for (int i = 0; i < n; ++i) {
    cerr << st[0][i] << "\n";
  }
  cerr << "END\n";*/

  cout << 2 << " " << ans.size() << "\n";
  for (auto move : ans) {
    cout << move.first << " " << move.second << "\n";
  }
  return 0;
}
